// import 'dart:convert';
//
// import 'package:apk_update/utils/connectivity_util.dart';
// import 'package:apk_update/utils/toast_util.dart';
// import 'package:apk_update/widget/update_dialog.dart';
// import 'package:dio/dio.dart';
// import 'package:flustars_flutter3/flustars_flutter3.dart';
// import 'package:get/route_manager.dart';
// import '../../core/common/constants.dart';
// import '../../core/common/servier_api.dart';
//
// /// 获取更新版本信息
// /// url 请求地址
// /// versionNumber 当前应用versionCode
// /// productNo 产品号
// /// onceDay 一天提示一次(应用首页设置true)
// void checkVersion(
//     {required String url,
//       required Method method,
//       Map<String, dynamic>? params,
//       Map<String, dynamic>? header,
//       bool onceDay = false,
//       Function()? jumpAppStore, // 跳转AppStore
//       Function(String? path)? installApk, // 安装Apk
//       Function()? downloadApkError, // 下载Apk错误
//       Function(String? path, String? apkPath)? downloadApk, // 使用OSS下载Apk
//       int? isOssDownload //1 使用OSS下载
//     }) async {
//
//
//   try {
//     final Response response = await DioUpdateUtil.getDio().request(
//       url,
//       options: Options(method: method.value, headers: header),
//       queryParameters: params,
//       data: params,
//     );
//     // 网络请求成功
//     printLog(response); // 打印日志
//     var responseData = response.data;
//     if (responseData.runtimeType == String) {
//       // 兼容后端数据返回string
//       responseData = json.decode(responseData);
//     }
//     if (responseData?["code"] != 0) {
//       ToastUtil.showToast(responseData?["msg"]);
//       return;
//     }
//     var result = responseData?["data"];
//     //获取当前时间
//     String spCurrent = SpUtil.getString(Constants.spCurrentDay) ?? "";
//     String current = DateUtil.formatDate(DateTime.now(), format: Constants.dateFormat);
//     //一天提示一次升级 & 非强升 & 当天已提示 => 不再提示
//     if (onceDay && result?['versionForce'] == 0 && spCurrent == current) {
//       // 不再提示
//       return;
//     }
//     //缓存当前时间
//     SpUtil.putString(Constants.spCurrentDay, current);
//     // 一天提示一次升级，是在应用首次设置，不需要提示最新版本toast
//     if (!onceDay && result == null) {
//       // 当前已经是最新版本
//       ToastUtil.showToast("已经是最新版本了！");
//       return;
//     }
//     if (result == null) {
//       // 无升级任务，拦截
//       return;
//     }
//     // 升级弹框提示
//     Get.dialog(
//       UpdateDialog(
//         title: result['versionName'],
//         content: result['tipContent'] ?? result['versionContent'],
//         versionForce: result['versionForce'] == 1,
//         versionPath: result['versionPath'],
//         jumpAppStore: jumpAppStore,
//         installApk: installApk,
//         isOssDownload: isOssDownload,
//         downloadApk: downloadApk,
//         downloadApkError: downloadApkError,
//       ),
//     );
//   } on DioException catch (e) {
//     printLog(e.response); // 打印日志
//     ToastUtil.showToast("服务器请求错误");
//   }
// }
//
// /// 检查版本(项目管理工具)
// void checkVersionPM(
//     {required String baseUrl,
//       Map<String, dynamic>? params,
//       bool onceDay = false,
//       Function()? jumpAppStore, // 跳转AppStore
//       Function(String? path)? installApk, // 安装Apk
//       Function()? downloadApkError, // 下载Apk错误
//       Function(String? path, String? apkPath)? downloadApk, // 使用OSS下载Apk
//       int? isOssDownload //1 使用OSS下载
//     }) async {
//   // 判断网络是否连接
//   var resList = await connectivity.checkConnectivity();
//
//   if (resList.isNotEmpty && resList[0] == ConnectivityResult.none) {
//     ToastUtil.showToast("网络异常,请检查网络");
//     return;
//   }
//
//   try {
//     final Response response = await DioUpdateUtil.getDio().request(
//       "$baseUrl${ServerApi.getLatestByProductCodePM}",
//       options: Options(
//           method: Method.get.value, headers: {"productGroupCode": "common"}),
//       queryParameters: params,
//     );
//     // 网络请求成功
//     printLog(response); // 打印日志
//     var responseData = response.data;
//     if (responseData.runtimeType == String) {
//       // 兼容后端数据返回string
//       responseData = json.decode(responseData);
//     }
//     if (responseData?["code"] != 0) {
//       ToastUtil.showToast(responseData?["msg"]);
//       return;
//     }
//     var result = responseData?["data"];
//     // 是否是最新版本提示
//     final newVersion = int.tryParse(result?['version']?.toString() ?? '') ?? 0;
//     final currentVersion =
//         int.tryParse(params?["currentVersion"]?.toString() ?? '') ?? 0;
//     if (newVersion <= currentVersion) {
//       if (!onceDay) {
//         ToastUtil.showToast('已经是最新版本了！');
//       }
//       return;
//     }
//     // 获取新版本详情
//     getVersionDetailPM(
//       baseUrl: baseUrl,
//       id: result?['id'],
//       onceDay: onceDay,
//       versionNumber: params?["currentVersion"],
//       jumpAppStore: jumpAppStore,
//       installApk: installApk,
//       downloadApkError: downloadApkError,
//       downloadApk: downloadApk,
//       isOssDownload: isOssDownload,
//     );
//   } on DioException catch (e) {
//     printLog(e.response); // 打印日志
//     ToastUtil.showToast("服务器请求错误");
//   }
// }
//
// /// 获取版本详情(项目管理工具)
// void getVersionDetailPM({
//   required String baseUrl,
//   required int? id,
//   required bool onceDay,
//   required int? versionNumber,
//   Function()? jumpAppStore, // 跳转AppStore
//   Function(String? path)? installApk, // 安装Apk
//   Function()? downloadApkError, // 下载Apk错误
//   Function(String? path, String? apkPath)? downloadApk, // 使用OSS下载Apk
//   int? isOssDownload, //1 使用OSS下载
// }) async {
//   // 判断网络是否连接
//   var resList = await connectivity.checkConnectivity();
//
//   if (resList.isNotEmpty && resList[0] == ConnectivityResult.none) {
//     ToastUtil.showToast("网络异常,请检查网络");
//     return;
//   }
//
//   try {
//     final Response response = await DioUpdateUtil.getDio().request(
//       "$baseUrl${ServerApi.getDetailPM}",
//       options: Options(method: Method.get.value, headers: {
//         'productGroupCode': 'common',
//       }),
//       queryParameters: {'id': id},
//     );
//     // 网络请求成功
//     printLog(response); // 打印日志
//     var responseData = response.data;
//     if (responseData.runtimeType == String) {
//       // 兼容后端数据返回string
//       responseData = json.decode(responseData);
//     }
//     if (responseData?["code"] != 0) {
//       ToastUtil.showToast(responseData?["msg"]);
//       return;
//     }
//     var result = responseData?["data"];
//     //获取当前时间
//     String spCurrent = SpUtil.getString(Constants.spCurrentDay) ?? "";
//     String current = DateUtil.formatDate(DateTime.now(), format: Constants.dateFormat);
//     // 是否是强升
//     final versionForce = result?['forceUpgradeStatus'] == 1;
//     //一天提示一次升级 & 非强升 & 当天已提示 => 不再提示
//     if (onceDay && !versionForce && spCurrent == current) {
//       // 不再提示
//       return;
//     }
//     //缓存当前时间
//     SpUtil.putString(Constants.spCurrentDay, current);
//     // 一天提示一次升级，是在应用首次设置，不需要提示最新版本toast
//     if (!onceDay && result == null) {
//       // 当前已经是最新版本
//       ToastUtil.showToast("已经是最新版本了！");
//       return;
//     }
//     // 是否是最新版本提示
//     final newVersion = int.tryParse(result?['version']?.toString() ?? '') ?? 0;
//     final currentVersion = int.tryParse(versionNumber?.toString() ?? '') ?? 0;
//     if (newVersion <= currentVersion) {
//       if (!onceDay) {
//         ToastUtil.showToast('已经是最新版本了！');
//       }
//       return;
//     }
//
//     // 升级弹框提示
//     Get.dialog(
//       UpdateDialog(
//         title: result['name'],
//         content: result['popContent'],
//         versionForce: result['forceUpgradeStatus'] == 1,
//         versionPath: result['versionPath'],
//         jumpAppStore: jumpAppStore,
//         installApk: installApk,
//         isOssDownload: isOssDownload,
//         downloadApk: downloadApk,
//         downloadApkError: downloadApkError,
//       ),
//     );
//   } on DioException catch (e) {
//     printLog(e.response); // 打印日志
//     ToastUtil.showToast("服务器请求错误");
//   }
// }