import 'package:flustars_flutter3/flustars_flutter3.dart';
import 'package:path/path.dart' as p;
import 'package:url_launcher/url_launcher.dart';


/// 处理apk下载url 获取 objectKey
String getObjectKey(String url) {
  int startIndex = url.indexOf("aliyuncs.com/") + "aliyuncs.com/".length;
  return url.substring(startIndex);
}

/// 获取下载url文件名
String getFileName(String url) {
  return p.basename(url);
}

/// 获取objectKey中的文件夹字符 “msl/common/prod/video/2025-06-20/app-release11.apk” 中获取 “msl/common/prod/video/2025-06-20”
String getPathByObjectKey(String url) {
  return p.dirname(url);
}

/// 创建下载目录
Future<String?> createDir() async {
  setInitDir(initStorageDir: true);
  await DirectoryUtil.getInstance();
  DirectoryUtil.createStorageDirSync(category: 'Download');
  String? path = DirectoryUtil.getStoragePath(category: 'Download');
  return path;
}

/// 打开浏览器
Future<void> openBrowser(String stringUrl) async {
  final Uri url = Uri.parse(stringUrl);

  if (!await launchUrl(url, mode: LaunchMode.externalApplication)) {
    throw Exception('Could not launch $url');
  }
}

/// 跳转 App Store 详情
void jumpAppStore(String id) async {
  String url = "https://apps.apple.com/cn/app/id$id";

  final uri = Uri.parse(url);
  if (await canLaunchUrl(uri)) {
    await launchUrl(
      uri,
      mode: LaunchMode.externalApplication,
    );
    return;
  }
}
